function [A, B] = col_rot(A, B, c, s);
%
% Function col_rot is the orthogonal rotation for any two column vectors A and B.
%
if ( s ~= 0 )
    nrow = size(A,1);
    t1 = A(1: nrow, 1);
    t2 = B(1: nrow, 1);
    A(1: nrow, 1) = conj(c) * t1 + conj(s) * t2;
    B(1: nrow, 1) = c * t2 - s * t1;
end   
