function [c, s] = givens(a, b);
%
%  Function Givens rotations
%      | a |   | * |
%  G * |   | = |   |, where G is a Givens rotation. G = [c s; -conj(s)  conj(c)]. 
%      | b |   | 0 |
%
fprintf('a = %g, b = %g \n',a,b)
if (b == 0)
    c = 1; s = 0;
else
    if ( abs(b) > abs(a) )
        tau = abs(a) / abs(b);
        tau = abs(b) * sqrt(1 + tau * tau);
        s = conj(b) / tau; 
        c = conj(a) / tau;
    else
        tau = abs(b) / abs(a); 
        tau = abs(a) * sqrt(1 + tau * tau);
        c = conj(a) / tau; 
        s = conj(b) / tau;
    end
end   
