function [v, beta] = house(x);
%
% Function: Householder reflector H=I-beta*v*v'
%
n = length(x);
v = x;
sigma = x(2: n, 1)' * x(2: n, 1);
if ( sigma == 0 )
    beta = 0;
else
    if ( sign(x(1, 1)) == 0 )
        v(1, 1) = -sqrt(sigma);
        beta = 1 / sigma;
    else   
        mu = sqrt( x(1, 1) * x(1, 1) + sigma ) ;
        if ( x(1, 1) < 0 )
            v(1, 1) = x(1, 1) - mu;
        else
            v(1, 1) = -sigma / ( x(1, 1) + mu );
        end
        beta = 2 / ( sigma + v(1, 1) * v(1, 1) );
    end   
end