%
%  Main program
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  This program computes the periodic Schur decomposition (PSD) of the matrix product 
%
%             Bp^{-1} * Ap * ... * B1^{-1} * A1, where p is the period.
%
%  In addition, we can also select to accumulate the orthogonal matices Q_i's or Z_i's.
%
%  That is,  Q_j * B_j * Z_j = Bj,  Q_j * A_j * Z_{j-1} = Aj,  Z_0 = Z_p,  for j = 1: p, 
%
%  where  A1 is qusi-upper triangular and A2, ..., Ap, B1, ..., Bp are upper triangular matrices.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear 
format long e 

flag_zmat = input('Would you like to store orthogonal matrices Q_i ( 0 or 1 ) ===> ');  % "0" means NO; "1" means YES. 
if ( isempty(flag_zmat) == 1 )
    flag_zmat = 0; 
end    
flag_qmat = input('Would you like to store orthogonal matrices Z_i ( 0 or 1 ) ===> ');  % "0" means NO; "1" means YES. 
if ( isempty(flag_qmat) == 1 )
    flag_qmat = 0; 
end    

fid = fopen('output.txt','w+');      
    
     %initial
     [A, B, E, Q, S, R] = Ex1p2_DAREX_AbeBen();
n = size(A,1); 
m = size(R,1);
   
ZZ = [ zeros(n) A B; E' Q S; zeros(m,n) S' R ];

m         = size(ZZ,1);
n         = m / 2;
% ZZ        = [ AA1  AA1;  AA0-AA1.'  AA1 ]; 
K         = [ zeros(2*n)  ZZ.'-ZZ;  ZZ-ZZ.'  zeros(2*n)];
N         = [ -ZZ  zeros(2*n); zeros(2*n)  -ZZ.' ]; 
[K1,N1,HR,tau,mtx_C,mtx_S] = patel(K,N);  

K11       = K1(1:2*n,1:2*n);
N11       = N1(1:2*n,1:2*n); 
AA        = zeros(n,n,2);
BB        = zeros(n,n,2);
R1        = zeros(n);
R2        = zeros(n);
R3        = zeros(n);
R4        = zeros(n);
for j=1:n
    for k=1:n
        R1(j,k) = K11(2*j-1,2*k);
        R2(j,k) = K11(2*j,2*k-1);
        R3(j,k) = N11(2*j-1,2*k-1);
        R4(j,k) = N11(2*j,2*k);
    end
end

AA(:,:,1) = R2;
AA(:,:,2) = R1;
BB(:,:,1) = R4;
BB(:,:,2) = R3;
p         = 2;

[Pi_a, Pi_b, alpha_j, beta_j, A, B, Qmat, Zmat, flag_uc] = pqz(AA, BB, flag_qmat, flag_zmat, p);
%      [a_pqr, b_pqr, hatA, hatB, Q, Z] = fun_PSD(A, B, flag_zmat, flag_qmat, p);
     %  For i = 1: n, ( a_pqr(i,1), b_pqr(i,1) ) denotes an eigenvalue pair of the periodic matrix
     %      pair {Aj, Bj}, j = 1: p. 
          
     output_main
                                                    
fclose(fid);
%
%  End program
%