%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  The Periodic QR step with double shifts.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Calculation of double shifts
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Emat = eye(2);
bdp = 1;
tmp_B = zeros(2);
          
for k = p: -1: 1
    tmp_b = B(nn1, nn1, k) * B(nn, nn, k);
    bdp = bdp * tmp_b;
    tmp_B = [B(nn, nn, k)  -B(nn1, nn, k);
                  0         B(nn1, nn1, k)];
    tmp_B = tmp_B * A(nn1: nn, nn1: nn, k);
    Emat = Emat * tmp_B;
end %{k}   
% if ( bdp <= eps )
%     bdp = eps;
% end    
Emat = Emat ./ bdp;
ss = Emat(1, 1) + Emat(2, 2);
sp = det(Emat); 
    
bdp = B(pp1, pp1, 1) * B(pp2, pp2, 1);
vec_B = [B(pp2, pp2, 1)  -B(pp1, pp2, 1);
                0         B(pp1, pp1, 1)] * A(pp1: pp2, pp1, 1);
b_11 = B(pp1, pp1, 1);
a_11 = 1;

for k = 2: p
    tmp_b = B(pp1, pp1, k) * B(pp2, pp2, k);
    bdp = bdp * tmp_b;
    b_11 = b_11 * B(pp1, pp1, k);
    a_11 = a_11 * A(pp1, pp1, k);
    vec_B = A(pp1: pp2, pp1:pp2, k) * vec_B ;
    vec_B = [B(pp2, pp2, k)  -B(pp1, pp2, k);
                    0         B(pp1, pp1, k)] * vec_B ;
end %{k}    
w1 = A(pp1:pp3, pp1:pp2, 1) * vec_B ;
w1(1,1) = w1(1,1) + (sp * b_11) / a_11 - ( ss * A(pp1, pp1, 1) ) ;
w1(2,1) = w1(2,1) - ( ss * A(pp2, pp1, 1) ) ; 
    
%%%%%%%%%%%%%%%%%%%%%
%    
%  Periodic QR step 
%    
%%%%%%%%%%%%%%%%%%%%%
        
for i = pp1: nn2
        
    if ( i > pp1 )
        w1 = [A(i, i-1, 1); A(i+1, i-1, 1); A(i+2, i-1, 1)];
    end  
    [vk1, bk] = house(w1);
    if ( bk ~= 0 )
        bv1 = bk * vk1;
        if ( i > pp1 )
            A(i: i+2, i-1: n, 1) = A(i: i+2, i-1: n, 1) - bv1 * ( vk1' * A(i: i+2, i-1: n, 1) );
            A(i+1, i-1, 1) = 0; 
            A(i+2, i-1, 1) = 0;
            %if ( flag_zmat == 1 )
            %    Z(i: i+2, :, 1) = Z(i: i+2, :, 1) - bv1 * ( vk1' * Z(i: i+2, :, 1) );  
            %end 
            B(i: i+2, i: n, 1) = B(i: i+2, i: n, 1) - bv1 * ( vk1' * B(i: i+2, i: n, 1) );
        else %{ i = pp1 }
            A(pp1: pp3, pp1: n, 1) = A(pp1: pp3, pp1: n, 1) - bv1 * ( vk1' * A(pp1: pp3, pp1: n, 1) );
            %if ( flag_zmat == 1 )
            %    Z(pp1: pp3, :, 1) = Z(pp1: pp3, :, 1) - bv1 * ( vk1' * Z(pp1: pp3, :, 1) );  
            %end 
            B(pp1: pp3, pp1: n, 1) = B(pp1: pp3, pp1: n, 1) - bv1 * ( vk1' * B(pp1: pp3, pp1: n, 1) );
        end 
    end
            
    for k = 1: p
                        
        w1 = [B(i+2, i+2, k); B(i+2, i+1, k); B(i+2, i, k)];
        [vk1, bk] = house(w1);
        if ( bk ~= 0 )
            vk1 = flipud(vk1);
            bv1 = bk * vk1; 
            B(1: i+2, i: i+2, k) = B(1: i+2, i: i+2, k) - ( B(1: i+2, i: i+2, k) * vk1 ) * bv1';
            B(i+2, i+1, k) = 0;
            B(i+2, i, k) = 0;
            if ( k < p )
                A(1: i+2, i: i+2, k+1) = A(1: i+2, i: i+2, k+1) - ( A(1: i+2, i: i+2, k+1) * vk1 ) * bv1';   
                %if ( flag_qmat == 1 )
                    Q(:, i: i+2, k+1) = Q(:, i: i+2, k+1) - ( Q(:, i: i+2, k+1) * vk1 ) * bv1';  
                %end
            else %{k = p}
                if ( i < nn2 )
                    A(1: i+3, i: i+2, 1) = A(1: i+3, i: i+2, 1) - ( A(1: i+3, i: i+2, 1) * vk1 ) * bv1';
                    %if ( flag_qmat == 1 )
                        Q(:, i: i+2, 1) = Q(:, i: i+2, 1) - ( Q(:, i: i+2, 1) * vk1 ) * bv1';  
                    %end
                else
                    A(1: nn, nn2: nn, 1) = A(1: nn, nn2: nn, 1) - ( A(1: nn, nn2: nn, 1) * vk1 ) * bv1';
                    %if ( flag_qmat == 1 )
                        Q(:, nn2: nn, 1) = Q(:, nn2: nn, 1) - ( Q(:, nn2: nn, 1) * vk1 ) * bv1';  
                    %end
                end    
            end %{if}   
        end %{if}        
         
        w2 = [B(i+1, i+1, k); B(i+1, i, k)];
        [vk2, bk] = house(w2);
        if ( bk ~= 0 )
            vk2 = flipud(vk2);
            bv2 = bk * vk2;
            B(1: i+1, i: i+1, k) = B(1: i+1, i: i+1, k) - ( B(1: i+1, i: i+1, k) * vk2 ) * bv2';
            B(i+1, i, k) = 0;
            if ( k < p )
                A(1: i+2, i: i+1, k+1) = A(1: i+2, i: i+1, k+1) - ( A(1: i+2, i: i+1, k+1) * vk2 ) * bv2';
                %if ( flag_qmat == 1 )
                    Q(:, i: i+1, k+1) = Q(:, i: i+1, k+1) - ( Q(:, i: i+1, k+1) * vk2 ) * bv2';  
                %end
            else %{k = p}
                if ( i < nn2 )
                    A(1: i+3, i: i+1, 1) = A(1: i+3, i: i+1, 1) - ( A(1: i+3, i: i+1, 1) * vk2 ) * bv2';
                    %if ( flag_qmat == 1 )
                        Q(:, i: i+1, 1) = Q(:, i: i+1, 1) - ( Q(:, i: i+1, 1) * vk2 ) * bv2';  
                    %end
                else    
                    A(1: nn, nn2: nn1, 1) = A(1: nn, nn2: nn1, 1) - ( A(1: nn, nn2: nn1, 1) * vk2 ) * bv2';
                    %if ( flag_qmat == 1 )
                        Q(:, nn2: nn1, 1) = Q(:, nn2: nn1, 1) - ( Q(:, nn2: nn1, 1) * vk2 ) * bv2';  
                    %end
                end    
            end %{if}    
        end  %{if}      
        
        if ( k < p )
            w1 = [A(i, i, k+1); A(i+1, i, k+1); A(i+2, i, k+1)];
            [vk1, bk] = house(w1);
            if ( bk ~= 0 )
                bv1 = bk * vk1;
                A(i: i+2, i: n, k+1) = A(i: i+2, i: n, k+1) - bv1 * ( vk1' * A(i: i+2, i: n, k+1) );
                A(i+1, i, k+1) = 0; 
                A(i+2, i, k+1) = 0;
                %if ( flag_zmat == 1 )
                %    Z(i: i+2, :, k+1) = Z(i: i+2, :, k+1) - bv1 * ( vk1' * Z(i: i+2, :, k+1) );  
                %end 
                B(i: i+2, i: n, k+1) = B(i: i+2, i: n, k+1) - bv1 * ( vk1' * B(i: i+2, i: n, k+1) );
            end
        
            w2 = [A(i+1, i+1, k+1); A(i+2, i+1, k+1)];
            [vk2, bk] = house(w2);
            if ( bk ~= 0 )
                bv2 = bk * vk2;
                A(i+1: i+2, i+1: n, k+1) = A(i+1: i+2, i+1: n, k+1) - bv2 * ( vk2' * A(i+1: i+2, i+1: n, k+1) );
                A(i+2, i+1, k+1) = 0;
                %if ( flag_zmat == 1 )
                %    Z(i+1: i+2, :, k+1) = Z(i+1: i+2, :, k+1) - bv2 * ( vk2' * Z(i+1: i+2, :, k+1) );  
                %end 
                B(i+1: i+2, i: n, k+1) = B(i+1: i+2, i: n, k+1) - bv2 * ( vk2' * B(i+1: i+2, i: n, k+1) );
            end %{if}
        end %{if}  
            
    end % {for k}
    
end % {for i}
%
%  i = nn - 1
%
w2 = [A(nn1, nn2, 1); A(nn, nn2, 1)];
[vk2, bk] = house(w2);
if ( bk ~= 0 )
    bv2 = bk * vk2;
    A(nn1: nn, nn2: n, 1) = A(nn1: nn, nn2: n, 1) - bv2 * ( vk2' * A(nn1: nn, nn2: n, 1) );
    A(nn, nn2, 1) = 0;
    B(nn1: nn, nn1: n, 1) = B(nn1: nn, nn1: n, 1) - bv2 * ( vk2' * B(nn1: nn, nn1: n, 1) );
    %if ( flag_zmat == 1 )
    %    Z(nn1: nn, :, 1) = Z(nn1: nn, :, 1) - bv2 * ( vk2' * Z(nn1: nn, :, 1) );  
    %end 
end %{if}

for k = 1: p
               
    w2 = [B(nn, nn, k); B(nn, nn1, k)];
    [vk2, bk] = house(w2);
    if ( bk ~= 0 )
        vk2 = flipud(vk2);
        bv2 = bk * vk2;
        B(1: nn, nn1: nn, k) = B(1: nn, nn1: nn, k) - ( B(1: nn, nn1: nn, k) * vk2 ) * bv2';
        B(nn, nn1, k) = 0;
        if ( k < p )
            A(1: nn, nn1: nn, k+1) = A(1: nn, nn1: nn, k+1) - ( A(1: nn, nn1: nn, k+1) * vk2 ) * bv2';
            %if ( flag_qmat == 1 )
                Q(:, nn1: nn, k+1) = Q(:, nn1: nn, k+1) - ( Q(:, nn1: nn, k+1) * vk2 ) * bv2';  
            %end
        else %{k = p}
            A(1: nn, nn1: nn, 1) = A(1: nn, nn1: nn, 1) - ( A(1: nn, nn1: nn, 1) * vk2 ) * bv2';
            %if ( flag_qmat == 1 )
                Q(:, nn1: nn, 1) = Q(:, nn1: nn, 1) - ( Q(:, nn1: nn, 1) * vk2 ) * bv2';  
            %end
        end %{if}    
    end  %{if}      
    
    if ( k < p )
        w2 = [A(nn1, nn1, k+1); A(nn, nn1, k+1)];
        [vk2, bk] = house(w2);
        if ( bk ~= 0 )
            bv2 = bk * vk2;
            A(nn1: nn, nn1: n, k+1) = A(nn1: nn, nn1: n, k+1) - bv2 * ( vk2' * A(nn1: nn, nn1: n, k+1) );
            A(nn, nn1, k+1) = 0;
            %if ( flag_zmat == 1 )
            %    Z(nn1: nn, :, k+1) = Z(nn1: nn, :, k+1) - bv2 * ( vk2' * Z(nn1: nn, :, k+1) );  
            %end 
            B(nn1: nn, nn1: n, k+1) = B(nn1: nn, nn1: n, k+1) - bv2 * ( vk2' * B(nn1: nn, nn1: n, k+1) );
        end %{if}
    end %{if}    
            
end % {for k}