%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  The PSD (or PQZ) algorithm
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Pi_a, Pi_b, alpha_j, beta_j, A, B, Qmat, Zmat, flag_uc] = pqz(A, B, flag_qmat, flag_zmat, p)

n = size(A(:, :, 1), 1);
tol = eps;
pp = 0; nn = 0; qq = 0;
flag_uc = 0;  
old_pp1 = 1;
old_nn = n;
Pi_a = zeros(n, 1);
Pi_b = zeros(n, 1);
alpha_j = zeros(p, n);   beta_j = zeros(p, n);

for k = 1: p
    Z(:, :, k) = eye(n); 
    Q(:, :, k) = eye(n);
end

hess_tri_form

maxiter = 50;  ite = 0;
while ( qq < n )
           
       for i = 2: n
           t21 = abs(A(i, i-1, 1));
           t11 = abs(A(i-1, i-1, 1));
           t22 = abs(A(i, i, 1));
           t12 = t11 + t22;
           err = tol * t12 ;
           if ( t21 <= err ) 
               A(i, i-1, 1) = 0;
           end % {if}
       end % {for}
           
       find_pq
          
       if ( qq < n )
           nn = n - qq;  nn1 = nn - 1;  nn2 = nn - 2;
           pp1 = pp + 1;  pp2 = pp + 2;  pp3 = pp + 3;
                             
           %pqr_step       
           pqz_step
           
           if ( nn == old_nn ) && ( pp1 == old_pp1 )
               ite = ite + 1;
               old_nn = nn;
               old_pp1 = pp1;
           else
               ite = 0;
           end   
                      
           if ( ite == maxiter )
               flag_uc = 1;
%                disp(' ')
%                disp('  Warning ! the pqz algorithm can not converge.')
%                disp(' ')
               break
           end
       end %{if}
       
end %{for}  

if ( flag_uc == 0 )
    p_eig
end    

for k = 1: p-1
    Qmat(:, :, k) = Z(:, :, k);
    Zmat(:, :, k) = Q(:, :, k+1);    
end    
Qmat(:, :, p) = Z(:, :, p);
Zmat(:, :, p) = Q(:, :, 1);
    
