function [A, B] = row_rot(A, B, c, s);
%
% Function row_rot is the orthogonal rotation for any two row vectors A and B.
%
if ( s ~= 0 )
    ncol = size(A,2);
    t1 = A(1, 1: ncol);
    t2 = B(1, 1: ncol);
    A(1, 1: ncol) = c * t1 + s * t2;
    B(1, 1: ncol) = conj(c) * t2 - conj(s) * t1;
end   
